unit ZOE_FORM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Enum_cons, Enum, ZOlib, ZOelib, StdCtrls,
  Buttons, jpeg, ExtCtrls;

type
  TZOForm = class(TForm)
    Number: TEdit;
    Label1: TLabel;
    StopButton: TButton;
    OKButton: TBitBtn;
    TerminateLabel: TLabel;
    Image1: TImage;
    Label2: TLabel;
    Label3: TLabel;
    procedure shownumber(nn: longint);
    procedure FormActivate(Sender: TObject);
    procedure HaltOnEsc(Sender: TObject);
    procedure Formclose(Sender: TObject);
    procedure CloseForm(Sender: TObject; var Action: TCloseAction);
(* this procedure is activated whenthe form opens:
   see Object Inspector, Events, OnActivate *)
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ZOForm: TZOForm;
  proname,pfname: shortstring;  (* proname = project name *)
  printfileconn: boolean;

implementation


procedure TZOForm.shownumber(nn: longint);
var s: shortstring;
begin
  str(nn,s);
  number.text := '       '+ s;
end;

{$R *.DFM}

procedure TZOForm.FormActivate(Sender: TObject);
begin
  Preparations(proname,outf);
  Initialise1;
  ReadInFile(outf,proname);
  if (f >= 2) then begin
    Initialise2;
    if (not wrong) then begin
      repeat
        begin
          repeat
            Findnext(ready);
            if wrong then Foundleaf(false,last);
           until (ready or last or halted or haltit);
           Application.ProcessMessages;
        if (ready and (not wrong)) then Foundleaf(true,last);
       end;
      if last then shownumber(s00);
      until (last or halted or haltit);
     if not (halted or haltit) then giveresult(outf);
    end; (* if not wrong *)
   if halted then writeln(outf,'Program interrupted by user.');
  end; (* if f >= 2 *)
 if (s00 = 0) then begin
   Label2.visible := true;
   Label3.visible := true;
  end;
 if printfileconn then begin
   closefile(pfile);
  end;
 writeln(outf);
 closefile(outf);
 if haltit then
   TerminateLabel.caption := 'The program had to stop.';
 StopButton.visible := false;
 OKButton.visible := true;
 TerminateLabel.visible := true;
 OKButton.enabled := true;
 ActiveControl := OKButton;
 ShowHint := true;
end;

procedure TZOForm.HaltOnEsc(Sender: TObject);
begin
  if MessageDlg(
  'Are you sure you want to stop the enumerations?',
  mtConfirmation,[mbYes, mbNo],1) = mrYes
    then begin
      halted := true;
      TerminateLabel.caption := 'The program was interrupted';
     end;
end;

procedure TZOForm.Formclose(Sender: TObject);
begin
 ZOForm.close;
end;

procedure TZOForm.CloseForm(Sender: TObject; var Action: TCloseAction);
begin
 halted := true;
 writeln(outf,'Program closed by user.');
end;

end.
