Unit ZOMat;

Interface

const fmax = 200;
      gmax = 200;  (* related to constant numfmax in simul *)
(* If fmax and gmax are made higher than 255,
   then Bytes have to changed into Integers. *)

(* Adjac is adjacency matrix for simulations.
   This unit gives a simple implementation. *)

type
  Adjac = Object
    AdMat: array[1..fmax,1..gmax] of Boolean;
    Function Arc(i,j: Byte): Boolean;
    Procedure Def(i,j: Byte; c: Boolean);
    Procedure DefEqual(var m: Adjac; var errtext: shortstring);
    Procedure AllocateMat(f,g: Byte; var errtext: shortstring);
    Procedure DeallocateMat;
   end;

Implementation

Function Adjac.Arc(i,j: Byte): Boolean;
begin
  Arc := AdMat[i,j];
end;

Procedure Adjac.Def(i,j: Byte; c: Boolean);
begin
  AdMat[i,j] := c;
end;

Procedure Adjac.DefEqual(var m: Adjac; var errtext: shortstring);
var i,j: Byte;
begin
   Self.Admat := m.Admat;
end;

Procedure Adjac.AllocateMat(f,g: Byte; var errtext: shortstring);
begin
if ((fmax > fmax) or (g > gmax) or (fmax < 1) or (gmax < 1)) then
  errtext := 'Matrix is defined out of bounds.' else errtext := '';
end; (* AllocateMat *)

Procedure ADjac.DeallocateMat;
begin
end; (* DeAllocateMat *)

end.